package com.tmax.openframe;

import com.tmax.openframe.response.ResponseCode;
import com.tmax.openframe.Handling;
import com.tmax.openframe.option.*;
import com.tmax.openframe.eib.EIB;
import com.tmax.openframe.task.Task;
import com.tmax.openframe.SystemData;
import com.tmax.openframe.support.exception.*;
import com.tmax.openframe.dof.*;
import com.tmax.openframe.dto.*;
import com.tmax.openframe.mapper.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.openframe.tsq.TSQ;
import com.tmax.openframe.file.*;
import com.tmax.openframe.intervalcontrol.*;
import com.tmax.openframe.command.*;
import java.util.Objects;
import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.dto.OIVPDELT_InputDto;
import com.tmax.openframe.dto.OIVPDELT_OutputDto;
import com.tmax.openframe.variable.OIVPDELT_VariableContainer;
import com.tmax.openframe.variable.condition.*;
import com.tmax.openframe.variable.group.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.proobject.model.dataobject.DataObject;
import java.lang.Runnable;
import java.math.*;
import java.util.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPDELT implements Runnable {
    private @Getter Integer returnValue = 0;
    private @Getter OIVPDELT_VariableContainer container = new OIVPDELT_VariableContainer();
    Runnable _0000_MAIN = this::_0000_MAIN;
    Runnable _0100_FIRST_TIME = this::_0100_FIRST_TIME;
    Runnable _0200_DELETE = this::_0200_DELETE;
    Runnable _0300_GO_MAIN = this::_0300_GO_MAIN;
    Runnable _0800_CHECK_DATA = this::_0800_CHECK_DATA;
    Runnable _5100_ALWAYS_TEST = this::_5100_ALWAYS_TEST;
    Runnable _5200_INFO = this::_5200_INFO;
    Runnable _5300_RETURN_TRANS_ID = this::_5300_RETURN_TRANS_ID;
    Runnable _5400_QUIT = this::_5400_QUIT;
    Runnable _7100_RECEIVEMAP = this::_7100_RECEIVEMAP;
    Runnable _7200_SENDMAP = this::_7200_SENDMAP;
    Runnable _7250_SENDMAP_DATA = this::_7250_SENDMAP_DATA;
    Runnable _9100_INVALID_KEY = this::_9100_INVALID_KEY;
    Runnable _9999_ABORT = this::_9999_ABORT;
    Runnable GoTo;
    boolean Return;
    ArrayList<Runnable> MethodFlow = new ArrayList<>();
    {
        MethodFlow.add(_0000_MAIN);
        MethodFlow.add(_0100_FIRST_TIME);
        MethodFlow.add(_0200_DELETE);
        MethodFlow.add(_0300_GO_MAIN);
        MethodFlow.add(_0800_CHECK_DATA);
        MethodFlow.add(_5100_ALWAYS_TEST);
        MethodFlow.add(_5200_INFO);
        MethodFlow.add(_5300_RETURN_TRANS_ID);
        MethodFlow.add(_5400_QUIT);
        MethodFlow.add(_7100_RECEIVEMAP);
        MethodFlow.add(_7200_SENDMAP);
        MethodFlow.add(_7250_SENDMAP_DATA);
        MethodFlow.add(_9100_INVALID_KEY);
        MethodFlow.add(_9999_ABORT);
    }
    @Getter
    EIB eib = new Task().getEib();
    @Getter
    boolean Start;
    @Getter
    Handling handling = new Handling();
    @Getter
    SystemData systemData = new SystemData();
    @Getter
    @Setter
    WaitObject waitObject;
    @Getter
    @Setter
    OIVPDELT_InputDto inputDto;
    @Getter
    @Setter
    OIVPDELT_OutputDto outputDto;
    @Getter
    @Setter
    DataObject startInputDto;

    public OIVPDELT() {
        container.setDFHCOMMAREA(StringUtils.repeat(' ', 1));
    }

    public @Override void run() {
        run(_0000_MAIN, _9999_ABORT);
    }

    private void run(Runnable start) throws CicsException {
        run(start, null);
    }

    private void run(Runnable start, Runnable end) throws CicsException {
        List<Runnable> runList;
        if (end == null) {
            runList = Collections.singletonList(start);
        } else {
            runList = MethodFlow.subList(MethodFlow.indexOf(start),
                    MethodFlow.indexOf(end) + 1);
        }
        int i = 0;
        while (i < runList.size()) {
            runList.get(i).run();
            if (GoTo != null) {
                for (Runnable runUnit : runList) {
                    if (GoTo == runUnit) {
                        i = runList.indexOf(runUnit);
                        GoTo = null;
                        break;
                    }
                }
                if (GoTo != null) {
                    return;
                }
            } else {
                i++;
            }
            if (Return) {
                return;
            }
        }
    }

    void _0000_MAIN() throws CicsException {
        run(_5100_ALWAYS_TEST);
        if (GoTo != null || Return) {
            return;
        }
        if (OIVPDELT_WS_FIRST_TIME_FLAG_CONDITION.FIRST_TIME.test(container
                .getWS_FIRST_TIME_FLAG())) {
            run(_0100_FIRST_TIME);
            if (GoTo != null || Return) {
                return;
            }
        } else if (OIVPDELT_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.ENTER_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_0200_DELETE);
            if (GoTo != null || Return) {
                return;
            }
        } else if (OIVPDELT_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.PF1_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_0300_GO_MAIN);
            if (GoTo != null || Return) {
                return;
            }
        } else {
            run(_9100_INVALID_KEY);
            if (GoTo != null || Return) {
                return;
            }
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0100_FIRST_TIME() throws CicsException {
        container.setOIVPM06I(OIVPDELT_OIVPM06I.createDefaultValueInstance());
        container.setMSGO("ENTER TO DELETE");
        run(_5200_INFO);
        if (GoTo != null || Return) {
            return;
        }
        // ("EXEC CICS READQ TS QUEUE(TSQ01) INTO(WSKEY) LENGTH(LEN1) ITEM(ITEM01) END-EXEC");
        try {
            ReadqTSOption option = ReadqTSOption.builder()
                    .queue(container.getTSQ01())
                    .into(container.getPEOPLE_INFO().getWSKEY())
                    .length((int) container.getLEN1())
                    .item((int) container.getITEM01()).build();
            TSQ.read(option);
            container.getPEOPLE_INFO().setWSKEY((int) option.getInto());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS READ FILE(FILE01) RIDFLD(WSKEY) KEYLENGTH(LEN) INTO(PEOPLE-INFO) LENGTH(DATALEN) END-EXEC");
        try {
            ReadOption option = ReadOption
                    .builder()
                    .file(container.getFILE01())
                    .ridfld(String.valueOf(container.getPEOPLE_INFO()
                            .getWSKEY()))
                    .keylength((int) container.getLEN())
                    .into(OIVPDELT_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                            .toTarget(container.getPEOPLE_INFO()))
                    .length((int) container.getDATALEN()).build();
            File.read(option, OIVPDS_DOF.class);
            container
                    .setPEOPLE_INFO(OIVPDELT_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                            .toSource((OIVPDS_DO) option.getInto()));
            container.getPEOPLE_INFO().setWSKEY(
                    Integer.parseInt(option.getRidfld()));
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setIDENO(String
                .valueOf(container.getPEOPLE_INFO().getWSKEY()));
        container.setNAMEO(container.getPEOPLE_INFO().getWS_NAME());
        container.setDEPTO(container.getPEOPLE_INFO().getWS_DEPARTMENT());
        container.setPHONO(container.getPEOPLE_INFO().getWS_PHONE());
        container.setEMALO(container.getPEOPLE_INFO().getWS_EMAIL());
        container.setADDRO(container.getPEOPLE_INFO().getWS_ADDRESS());
        // ("EXEC CICS DELETEQ TS QUEUE(TSQ01) END-EXEC");
        try {
            DeleteqTSOption option = DeleteqTSOption.builder()
                    .queue(container.getTSQ01()).build();
            TSQ.delete(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        run(_7200_SENDMAP);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0200_DELETE() throws CicsException {
        run(_7100_RECEIVEMAP);
        if (GoTo != null || Return) {
            return;
        }
        container.getPEOPLE_INFO().setWSKEY(
                Integer.parseInt(container.getOIVPM06I().getIDENI()));
        run(_0800_CHECK_DATA);
        if (GoTo != null || Return) {
            return;
        }
        // ("EXEC CICS DELETE FILE(FILE01) RIDFLD(WSKEY) KEYLENGTH(LEN) END-EXEC");
        try {
            DeleteOption option = DeleteOption
                    .builder()
                    .file(container.getFILE01())
                    .ridfld(String.valueOf(container.getPEOPLE_INFO()
                            .getWSKEY())).keylength((int) container.getLEN())
                    .build();
            File.delete(option, OIVPDS_DOF.class);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setMSGO("DATA DELETED");
        // ("EXEC CICS DELAY INTERVAL(3) REQID('DELAYDEL') END-EXEC");
        try {
            DelayOption option = DelayOption.builder().interval(3)
                    .isDuration(true).reqid("DELAYDEL").build();
            IntervalControlService.delay(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        run(_7250_SENDMAP_DATA);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0300_GO_MAIN() throws CicsException {
        // ("EXEC CICS START TRANSID('OIVP') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIVP")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPMAIN_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0800_CHECK_DATA() throws CicsException {
        // ("EXEC CICS READ FILE(FILE01) RIDFLD(WSKEY) KEYLENGTH(LEN) INTO(PEOPLE-INFO) LENGTH(DATALEN) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            ReadOption option = ReadOption
                    .builder()
                    .file(container.getFILE01())
                    .ridfld(String.valueOf(container.getPEOPLE_INFO()
                            .getWSKEY()))
                    .keylength((int) container.getLEN())
                    .into(OIVPDELT_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                            .toTarget(container.getPEOPLE_INFO()))
                    .length((int) container.getDATALEN()).build();
            File.read(option, OIVPDS_DOF.class);
            container
                    .setPEOPLE_INFO(OIVPDELT_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                            .toSource((OIVPDS_DO) option.getInto()));
            container.getPEOPLE_INFO().setWSKEY(
                    Integer.parseInt(option.getRidfld()));
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        if (container.getWS_RESPONSE_CODE() == ResponseCode.NORMAL
                .getResponseCode()) {
        } else if (container.getWS_RESPONSE_CODE() == ResponseCode.NOTFND
                .getResponseCode()) {
            container.setMSGO("ALREADY DELETED");
            run(_7250_SENDMAP_DATA);
            if (GoTo != null || Return) {
                return;
            }
            run(_5300_RETURN_TRANS_ID);
            if (GoTo != null || Return) {
                return;
            }
        }
    }

    void _5100_ALWAYS_TEST() throws CicsException {
        container.setDEFINITIONS_OF_EIBAID_FIELD(eib.getEibAid());
        if (OIVPDELT_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.CLEAR_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_5400_QUIT);
            if (GoTo != null || Return) {
                return;
            }
        }
        // ("EXEC CICS ASSIGN STARTCODE(START-CODE) END-EXEC");
        try {
            AssignOption option = AssignOption.builder()
                    .startcode(container.getSTART_CODE()).inputDto(inputDto)
                    .build();
            SystemEnv.assign(option);
            container.setSTART_CODE(option.getStartcode());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        if (StringUtils.stripEnd(container.getSTART_CODE(), " ")
                .compareTo("TD") == 0 && eib.getEibCalen() != 0) {
            container.setWS_FIRST_TIME_FLAG(1);
        } else {
            container.setWS_FIRST_TIME_FLAG(0);
        }
    }

    void _5200_INFO() throws CicsException {
        // ("EXEC CICS LINK PROGRAM ('OIVPINFO') COMMAREA (WS-DATE-TIME-AREA) END-EXEC");
        try {
            LinkOption option = LinkOption
                    .builder()
                    .program("OIVPINFO")
                    .commarea(
                            OIVPDELT_WS_DATE_TIME_AREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                                    .toOIVPINFO_DFHCOMMAREADto(container
                                            .getWS_DATE_TIME_AREA()))
                    .inputDto(new OIVPINFO_InputDto()).build();
            ProgramInvoke.link(option);
            container
                    .setWS_DATE_TIME_AREA(OIVPDELT_WS_DATE_TIME_AREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                            .toOIVPDELT_WS_DATE_TIME_AREA((OIVPINFO_DFHCOMMAREADto) option
                                    .getCommarea()));
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setDATEO(container.getWS_DATE_TIME_AREA().getDCA_DATE());
        container.setTERMO(container.getWS_DATE_TIME_AREA().getDCA_TERM());
        container.setTIMEO(container.getWS_DATE_TIME_AREA().getDCA_TIME()
                .toString());
    }

    void _5300_RETURN_TRANS_ID() throws CicsException {
        // ("EXEC CICS RETURN TRANSID ('OIDE') COMMAREA (WS-COMMUNICATION-AREA) END-EXEC");
        try {
            OIVPDELT_DFHCOMMAREADto dfhcommareaDto = new OIVPDELT_DFHCOMMAREADto();
            dfhcommareaDto.setDFHCOMMAREA(container.getWS_COMMUNICATION_AREA());
            ReturnOption option = ReturnOption.builder().transid("OIDE")
                    .commarea(dfhcommareaDto).outputDto(outputDto).build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _5400_QUIT() throws CicsException {
        // ("EXEC CICS START TRANSID('OIQU') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIQU")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPQUIT_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                OIVPDELT_DFHCOMMAREADto dfhcommareaDto = new OIVPDELT_DFHCOMMAREADto();
                dfhcommareaDto.setDFHCOMMAREA(container.getDFHCOMMAREA());
                outputDto.getSystemDto().setCommarea("DFHCOMMAREA",
                        dfhcommareaDto);
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7100_RECEIVEMAP() throws CicsException {
        // ("EXEC CICS RECEIVE MAP ('OIVPM06') MAPSET ('OIVPM06') INTO (OIVPM06I) RESP (WS-RESPONSE-CODE) END-EXEC");
        try {
            ReceiveMapOption option = ReceiveMapOption.builder().build();
            OIVPM06_OIVPM06_dataToOIVPDELT_OIVPM06IMapperInterface.INSTANCE
                    .toTarget(
                            inputDto.getScreenDto().getOIVPM06_OIVPM06_data(),
                            container.getOIVPM06I());
            OIVPM06_OIVPM06_metaToOIVPDELT_OIVPM06IMapperInterface.INSTANCE
                    .toTarget(
                            inputDto.getScreenDto().getOIVPM06_OIVPM06_meta(),
                            container.getOIVPM06I());
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
    }

    void _7200_SENDMAP() throws CicsException {
        // ("EXEC CICS SEND MAP('OIVPM06') MAPSET('OIVPM06') FROM(OIVPM06O) ERASE END-EXEC");
        try {
            outputDto.setScreenDto(new OIVPDELT_ScreenDto());
            outputDto.setId("tranExecute");
            outputDto.getScreenDto().setMapName("OIVPM06");
            outputDto.getScreenDto().setMapSetName("OIVPM06");
            try {
                OIVPM06_OIVPM06_data oivpm06_oivpm06_data = new OIVPM06_OIVPM06_data();
                OIVPM06_OIVPM06_meta oivpm06_oivpm06_meta = new OIVPM06_OIVPM06_meta();
                OIVPDELT_OIVPM06OToOIVPM06_OIVPM06_dataMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM06O(), oivpm06_oivpm06_data);
                OIVPDELT_OIVPM06OToOIVPM06_OIVPM06_metaMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM06O(), oivpm06_oivpm06_meta);
                outputDto.getScreenDto().setOIVPM06_OIVPM06_data(
                        oivpm06_oivpm06_data);
                outputDto.getScreenDto().setOIVPM06_OIVPM06_meta(
                        oivpm06_oivpm06_meta);
            } catch (Exception e) {
                throw new CicsConditionException(47);
            }
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7250_SENDMAP_DATA() throws CicsException {
        // ("EXEC CICS SEND MAP('OIVPM06') MAPSET('OIVPM06') FROM(OIVPM06O) DATAONLY END-EXEC");
        try {
            outputDto.setScreenDto(new OIVPDELT_ScreenDto());
            outputDto.setId("tranExecute");
            outputDto.getScreenDto().setMapName("OIVPM06");
            outputDto.getScreenDto().setMapSetName("OIVPM06");
            try {
                OIVPM06_OIVPM06_data oivpm06_oivpm06_data = new OIVPM06_OIVPM06_data();
                OIVPM06_OIVPM06_meta oivpm06_oivpm06_meta = new OIVPM06_OIVPM06_meta();
                OIVPDELT_OIVPM06OToOIVPM06_OIVPM06_dataMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM06O(), oivpm06_oivpm06_data);
                OIVPDELT_OIVPM06OToOIVPM06_OIVPM06_metaMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM06O(), oivpm06_oivpm06_meta);
                outputDto.getScreenDto().setOIVPM06_OIVPM06_data(
                        oivpm06_oivpm06_data);
                outputDto.getScreenDto().setOIVPM06_OIVPM06_meta(
                        oivpm06_oivpm06_meta);
            } catch (Exception e) {
                throw new CicsConditionException(47);
            }
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _9100_INVALID_KEY() throws CicsException {
        container.setOIVPM06I(OIVPDELT_OIVPM06I.createDefaultValueInstance());
        container.setMSGO("INVALID KEY ENTERED");
        run(_7250_SENDMAP_DATA);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _9999_ABORT() throws CicsException {
        container.getWS_ERROR_MESSAGE().setWS_EIBTRNID(eib.getEibTranid());
        container.getWS_ERROR_MESSAGE().setWS_EIBRSRCE(eib.getEibRsrce());
        container.getWS_ERROR_MESSAGE().setWS_EIBRESP(eib.getEibResp());
        container.getWS_ERROR_MESSAGE().setWS_EIBRESP2(eib.getEibResp2());
        // ("EXEC CICS SEND TEXT FROM ('ERROR') ERASE ALARM FREEKB END-EXEC");
        try {
            outputDto.getScreenDto().setText("ERROR");
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                OIVPDELT_DFHCOMMAREADto dfhcommareaDto = new OIVPDELT_DFHCOMMAREADto();
                dfhcommareaDto.setDFHCOMMAREA(container.getDFHCOMMAREA());
                outputDto.getSystemDto().setCommarea("DFHCOMMAREA",
                        dfhcommareaDto);
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }
}
